
#include <windows.h>
#include <x86boot.h>
#include <kitl.h>
#include <oal.h>
#include <msr.h>



typedef struct _MSR_DATA
{
	unsigned long add;
	unsigned long edx;
	unsigned long eax;
	unsigned char accessType;//0=read  1=write
} MSR_DATA;

BOOL x86AccessMSR (
    UINT32 code, VOID *lpInBuf, UINT32 nInBufSize, VOID *lpOutBuf, 
    UINT32 nOutBufSize, UINT32 *lpBytesReturned
) {
    
	MSR_DATA *pInPortInfo  = (MSR_DATA*) lpInBuf;
	MSR_DATA *pOutPortInfo = (MSR_DATA*) lpOutBuf;

	unsigned int add=0,eax=0,edx=0;
	add=pInPortInfo->add;
	

	if(pInPortInfo->accessType==0)
	{
		NKrdmsr(add,&edx,&eax);	
	}else if(pInPortInfo->accessType==1)
	{
		NKwrmsr(add,edx,eax);	
	}

	pOutPortInfo->add=pInPortInfo->add;
	pOutPortInfo->edx=edx;
	pOutPortInfo->eax=eax;


    return TRUE;
}
